searchNodes=[{"doc":"Dredd judges data for you. It's a validator for a wide range of datastructures. See the README for a detailed guide.","ref":"Dredd.html","title":"Dredd","type":"module"},{"doc":"This is a convenience function in case you want to write your own validators. It will set the valid? flag of the given Dredd.Dataset to false. It will also create a Dredd.SingleError structure with the given values and assing it to the error field of the Dredd.Dataset .","ref":"Dredd.html#set_single_error/4","title":"Dredd.set_single_error/4","type":"function"},{"doc":"Validates the given values binaries. Optionally also validates the length of the binary either . Options :is - exact required length of a binary :min - minimal required length of a binary (should not be used together with is ) :max - maximal allowed length of a binary (should not be used together with is ) :type_message - error message in case the type is wrong; defaults to &quot;is not a binary&quot; :is_message - error message in case the exact length is wrong defaults to &quot;should be %{count} bytes(s)&quot; :min_message - error message in case the length is too short defaults to &quot;should be at least %{count} bytes(s)&quot; :max_message - error message in case the length is too long defaults to &quot;should be at &quot;should be at most %{count} bytes(s)&quot;","ref":"Dredd.html#validate_binary/2","title":"Dredd.validate_binary/2","type":"function"},{"doc":"Validates the given values is of type boolean. Optionally also validates against a specific boolean value. Options :is - the expected value ( true | false ) :wrong_type_message - error message, defaults to &quot;is not a boolean&quot; :wrong_value_message - error message, defaults to &quot;expected value: %{expected}&quot; Examples Simple case with data of invalid type: iex&gt; Dredd . validate_boolean ( &#39;foo&#39; ) % Dredd.Dataset { data : &#39;foo&#39; , error : % Dredd.SingleError { validator : :boolean , message : &quot;is not a boolean&quot; , metadata : %{ kind : :type } } , valid? : false } Simple case with valid boolean type: iex&gt; Dredd . validate_boolean ( true ) % Dredd.Dataset { data : true , error : nil , valid? : true } Special invalid case with optional expected value: iex&gt; Dredd . validate_boolean ( false , is : true ) % Dredd.Dataset { data : false , error : % Dredd.SingleError { validator : :boolean , message : &quot;expected value: %{expected}&quot; , metadata : %{ expected : true , kind : :value } } , valid? : false }","ref":"Dredd.html#validate_boolean/2","title":"Dredd.validate_boolean/2","type":"function"},{"doc":"Validates if the value of a given field is an email. NOTE: this validator is not RFC822 compliant. If you really need to be sure, send an email to that address. Options :message - error message, default to &quot;is not a valid email address&quot;","ref":"Dredd.html#validate_email/2","title":"Dredd.validate_email/2","type":"function"},{"doc":"Validates the value for the given field is not contained within the provided enumerable. Options :message - error message, defaults to &quot;is reserved&quot;","ref":"Dredd.html#validate_exclusion/3","title":"Dredd.validate_exclusion/3","type":"function"},{"doc":"Validates the value of the given field matches the provided format. Options :message - error message, defaults to &quot;has invalid format&quot;","ref":"Dredd.html#validate_format/3","title":"Dredd.validate_format/3","type":"function"},{"doc":"Validates the value for the given field is contained within the provided enumerable. Options :message - error message, defaults to &quot;is invalid&quot;","ref":"Dredd.html#validate_inclusion/3","title":"Dredd.validate_inclusion/3","type":"function"},{"doc":"Applies a validator function to a each element of a list contained in a field. Options :is - exact required length of a list :min - minimal required length of a list (should not be used together with is ) :max - maximal allowed length of a list (should not be used together with is ) :type_message - error message in case the type is wrong; defaults to &quot;is not a list&quot; :is_message - error message in case the exact length is wrong defaults to &quot;should be %{count} item(s)&quot; :min_message - error message in case the length is too short defaults to &quot;should be at least %{count} item(s)&quot; :max_message - error message in case the length is too long defaults to &quot;should be at &quot;should be at most %{count} item(s)&quot; Example","ref":"Dredd.html#validate_list/3","title":"Dredd.validate_list/3","type":"function"},{"doc":"Validates the structure of a Map, Keyword List, Struct or anything else that supports the Access behaviour and whose structure can be represented by a map. Options message - error message in case the type-check fails defaults to: &quot;is not a map&quot; Example iex&gt; value = %{ field_a : 10 , field_b : &quot;foo&quot; } %{ field_a : 10 , field_b : &quot;foo&quot; } iex&gt; validator_map = %{ ...&gt; field_a : &amp; Dredd . validate_string / 1 , ...&gt; field_b : fn data -&gt; Dredd . validate_number ( data , :integer ) end ...&gt; } iex&gt; Dredd . validate_map ( value , validator_map ) % Dredd.Dataset { data : %{ field_a : 10 , field_b : &quot;foo&quot; } , error : % Dredd.MapErrors { validator : :map , errors : %{ field_a : % Dredd.SingleError { validator : :string , message : &quot;is not a string&quot; , metadata : %{ kind : :type } } , field_b : % Dredd.SingleError { validator : :number , message : &quot;has incorrect numerical type&quot; , metadata : %{ kind : :integer } } } } , valid? : false }","ref":"Dredd.html#validate_map/3","title":"Dredd.validate_map/3","type":"function"},{"doc":"Validates if the value of a given field is a UUID.binary_to_string! Options :message - error message, defaults to &quot;is not a valid UUID&quot;","ref":"Dredd.html#validate_nanoid/2","title":"Dredd.validate_nanoid/2","type":"function"},{"doc":"Validates that the value of a field is a number. Supported types: :float :integer :non_neg_integer :pos_integer Options :message - error message, defaults to &quot;has invalid type&quot;","ref":"Dredd.html#validate_number/3","title":"Dredd.validate_number/3","type":"function"},{"doc":"Validates the given values is of type string. Optionally also validates the length of the string either as codepoints or graphemes. Options :is - exact required length of a string :min - minimal required length of a string (should not be used together with is ) :max - maximal allowed length of a string (should not be used together with is ) :count - can be :codepoints or :graphemes . Defaults to :graphemes :type_message - error message in case the type is wrong; defaults to &quot;is not a string&quot; :is_message - error message in case the exact length is wrong defaults to &quot;should be %{count} character(s)&quot; :min_message - error message in case the length is too short defaults to &quot;should be at least %{count} character(s)&quot; :max_message - error message in case the length is too long defaults to &quot;should be at &quot;should be at most %{count} character(s)&quot; Examples Here's a simple data with invalid data: iex&gt; Dredd . validate_string ( 10 ) % Dredd.Dataset { data : 10 , error : % Dredd.SingleError { validator : :string , message : &quot;is not a string&quot; , metadata : %{ kind : :type } } , valid? : false } Here's an example with a string that is too short but has a length requirement: iex&gt; Dredd . validate_string ( &quot;&quot; , min_length : 5 ) % Dredd.Dataset { data : &quot;&quot; , error : % Dredd.SingleError { validator : :string , message : &quot;should be at least %{count} character(s)&quot; , metadata : %{ count : 5 , kind : :min_length } } , valid? : false }","ref":"Dredd.html#validate_string/2","title":"Dredd.validate_string/2","type":"function"},{"doc":"Validates if the value of a given field is a UUID.binary_to_string! Options :message - error message, defaults to &quot;is not a valid UUID&quot;","ref":"Dredd.html#validate_uuid/2","title":"Dredd.validate_uuid/2","type":"function"},{"doc":"","ref":"Dredd.html#t:field_spec/0","title":"Dredd.field_spec/0","type":"type"},{"doc":"","ref":"Dredd.html#t:number_t/0","title":"Dredd.number_t/0","type":"type"},{"doc":"","ref":"Dredd.html#t:single_validator_fun/0","title":"Dredd.single_validator_fun/0","type":"type"},{"doc":"","ref":"Dredd.html#t:validator_map/0","title":"Dredd.validator_map/0","type":"type"},{"doc":"This is the internal datastructure used for passing the current validation state from validator to validator including the top-level error-structure of any validated datastructure.","ref":"Dredd.Dataset.html","title":"Dredd.Dataset","type":"module"},{"doc":"","ref":"Dredd.Dataset.html#new/1","title":"Dredd.Dataset.new/1","type":"function"},{"doc":"","ref":"Dredd.Dataset.html#t:error_t/0","title":"Dredd.Dataset.error_t/0","type":"type"},{"doc":"","ref":"Dredd.Dataset.html#t:t/0","title":"Dredd.Dataset.t/0","type":"type"},{"doc":"This datastructure shows where in a list validations failed.","ref":"Dredd.ListErrors.html","title":"Dredd.ListErrors","type":"module"},{"doc":"","ref":"Dredd.ListErrors.html#t:error_t/0","title":"Dredd.ListErrors.error_t/0","type":"type"},{"doc":"","ref":"Dredd.ListErrors.html#t:t/0","title":"Dredd.ListErrors.t/0","type":"type"},{"doc":"This datastructure shows for which fields in a struct validation failed.","ref":"Dredd.MapErrors.html","title":"Dredd.MapErrors","type":"module"},{"doc":"","ref":"Dredd.MapErrors.html#t:error_t/0","title":"Dredd.MapErrors.error_t/0","type":"type"},{"doc":"","ref":"Dredd.MapErrors.html#t:t/0","title":"Dredd.MapErrors.t/0","type":"type"},{"doc":"Represents an error on a single Value.","ref":"Dredd.SingleError.html","title":"Dredd.SingleError","type":"module"},{"doc":"","ref":"Dredd.SingleError.html#t:t/0","title":"Dredd.SingleError.t/0","type":"type"},{"doc":"Dredd judges data for you. It's a validator for a wide range of possibilities. datastructures. Started as a frok of Justify it's been rewritten to handle plain values as well as deeply nested structures and return understandable error-structures. Following in the footsteps of Ecto.Changeset , Dredd allows you to pipe values into a series of validation functions using a simple and familiar API. No schemas or casting required. Please see the Changelog for what has changed in the latest release. A Basic Example iex&gt; Dredd . validate_number ( &quot;this is not a number&quot; , :integer ) % Dredd.Dataset { data : &quot;this is not a number&quot; , error : % Dredd.SingleError { validator : :number , message : &quot;has incorrect numerical type&quot; , metadata : %{ kind : :integer } } , valid? : false } As you can see this is a rather verbose output; but we believe that this can come in handy in conjunction when you have to translate the error on the user interface. Each validation function will return a Dredd.Dataset which can be passed into the next function. If a validation error is encountered the dataset will be marked as invalid and an error will be added to the struct. Each validator behaves in a fail-fast manner. If the Dataset is already invalid no further validation happens for any given value. As a tip: you should order your validations by descending importance. Errors are distinguished by type to allow traversal of nested structures by matching against the struct type of the encountered error. When validating single values a Dredd.SingleError is returned whenever it fails.","ref":"readme.html","title":"Dredd","type":"extras"},{"doc":"To ramp up the complexits: you can validate all elements of a list by handing a validation function to Dredd.validate_list/3 . Simple List Example This is how you would validate a list of strings. iex(2)&gt; Dredd . validate_list ( [ &quot;string&quot; , - 1 , &quot;string&quot; , 0 ] , &amp; Dredd . validate_string / 1 ) % Dredd.Dataset { data : [ &quot;string&quot; , - 1 , &quot;string&quot; , 0 ] , error : % Dredd.ListErrors { validator : :list , errors : %{ 1 =&gt; % Dredd.SingleError { validator : :string , message : &quot;is not a string&quot; , metadata : %{ kind : :type } } , 3 =&gt; % Dredd.SingleError { validator : :string , message : &quot;is not a string&quot; , metadata : %{ kind : :type } } } } , valid? : false } If the list does not match given length requirements or the given data is not a list, the returned Dredd.Dataset will be invalid and contain a Dredd.SingleError . In case an element of the list is invalid, the returned Dredd.Dataset will contain Dredd.ListErrors with its errors field containing a map. The keys of that map are the indices of the values for which validation failed. The values of that map are Dredd.SingleError , Dredd.ListErrors or Dredd.MapErrors depending on the given validator for the list items. This distinction is meant to help with parsing the errors of nested validations. Complex List Example You can exploit the fact that cou can pipe the output of all validator functions into the next one and compose chain together multiple values for the elements of your list. iex&gt; item_validator = fn data -&gt; ...&gt; Dredd . validate_string ( data ) ...&gt; |&gt; Dredd . validate_email ( ) ...&gt; end iex&gt; Dredd . validate_list ( [ &quot;foo&quot; , &quot;foo@bar.com&quot; ] , item_validator ) % Dredd.Dataset { data : [ &quot;foo&quot; , &quot;foo@bar.com&quot; ] , error : % Dredd.ListErrors { validator : :list , errors : %{ 0 =&gt; % Dredd.SingleError { validator : :email , message : &quot;is not a valid email address&quot; , metadata : %{ } } } } , valid? : false } Handling Non-Lists In case Dredd.validate_list/3 is handed anything but a list, it will return a Dredd.SingleError indicating that the value is of wrong type: iex&gt; Dredd . validate_list ( 100 , &amp; Dredd . validate_email / 1 ) % Dredd.Dataset { data : 100 , error : % Dredd.SingleError { validator : :list , message : &quot;is not a list&quot; , metadata : %{ kind : :type } } , valid? : false }","ref":"readme.html#validating-lists","title":"Dredd - Validating Lists","type":"extras"},{"doc":"You can validate fields of a struct or map using the Dredd.validate_map/2 function. Simple Struct Example iex&gt; value = %{ field_a : 10 , field_b : &quot;foo&quot; } %{ field_a : 10 , field_b : &quot;foo&quot; } iex&gt; validator_map = %{ ...&gt; field_a : &amp; Dredd . validate_string / 1 , ...&gt; field_b : fn data -&gt; Dredd . validate_number ( data , :integer ) end ...&gt; } iex&gt; Dredd . validate_map ( value , validator_map ) % Dredd.Dataset { data : %{ field_a : 10 , field_b : &quot;foo&quot; } , error : % Dredd.MapErrors { validator : :map , errors : %{ field_a : % Dredd.SingleError { validator : :string , message : &quot;is not a string&quot; , metadata : %{ kind : :type } } , field_b : % Dredd.SingleError { validator : :number , message : &quot;has incorrect numerical type&quot; , metadata : %{ kind : :integer } } } } , valid? : false } In case of errors the output of Dredd.validate_map\\3 is quite similar to that of Dredd.validate_list\\3 . If the give value is not a valid map the Dredd.Dataset will contain a Dredd.SingleError . If the validations on field-level failed the Dredd.Dataset will contain Dredd.MapErrors . The keys in that map are the fieldnames of the invalid fields. The values in the map can be Dredd.SingleError , Dredd.ListErrors or Dredd.MapErrors depending on the valdiator of that field. This distinction is meant to help with parsing the errors of nested validations. Nested Example iex&gt; email_list_validator = fn data -&gt; ...&gt; Dredd . validate_list ( data , &amp; Dredd . validate_email / 1 ) ...&gt; end # Function&lt;...&gt; iex&gt; validate_embedded_map = fn data -&gt; ...&gt; validator_map = %{ ...&gt; email_list : email_list_validator , ...&gt; number : &amp; Dredd . validate_number ( &amp;1 , :integer ) ...&gt; } ...&gt; Dredd . validate_map ( data , validator_map ) ...&gt; end # Function&lt;...&gt; iex&gt; map_list_validator = fn data -&gt; ...&gt; Dredd . validate_list ( data , validate_embedded_map ) ...&gt; end # Function&lt;...&gt; iex&gt; validator_map = %{ ...&gt; map_list : map_list_validator , ...&gt; str_field : &amp; Dredd . validate_string / 1 ...&gt; } %{ map_list : # Function &lt; ... &gt; , str_field : &amp; Dredd . validate_string / 1 } iex&gt; value = %{ ...&gt; map_list : [ ...&gt; %{ email_list : [ &quot;foo@bar.com&quot; , &quot;bang@baz.net&quot; ] , number : 10 } , ...&gt; %{ email_list : [ &quot;foo@bar.com&quot; , &quot;blubb&quot; ] , number : 20 } ...&gt; ] , ...&gt; str_field : &quot;bar&quot; ...&gt; } %{ map_list : [ %{ email_list : [ &quot;foo@bar.com&quot; , &quot;bang@baz.net&quot; ] , number : 10 } , %{ email_list : [ &quot;foo@bar.com&quot; , &quot;blubb&quot; ] , number : 20 } ] , str_field : &quot;bar&quot; } iex&gt; Dredd . validate_map ( value , validator_map ) % Dredd.Dataset { data : %{ map_list : [ %{ email_list : [ &quot;foo@bar.com&quot; , &quot;bang@baz.net&quot; ] , number : 10 } , %{ email_list : [ &quot;foo@bar.com&quot; , &quot;blubb&quot; ] , number : 20 } ] , str_field : &quot;bar&quot; } , error : % Dredd.MapErrors { validator : :map , errors : %{ map_list : % Dredd.ListErrors { validator : :list , errors : %{ 1 =&gt; % Dredd.MapErrors { validator : :map , errors : %{ email_list : % Dredd.ListErrors { validator : :list , errors : %{ 1 =&gt; % Dredd.SingleError { validator : :email , message : &quot;is not a valid email address&quot; , metadata : %{ } } } } } } } } } } , valid? : false } In the example above, the second email in the list of the second sub-map in the map_list field is invalid. Even with all the extra information the output is quite confusing. That's the primary reason we've added all the extra type information. With that you can pattern match against the struct type and have a fighting chance at successfully traversing the data.","ref":"readme.html#validating-structs","title":"Dredd - Validating Structs","type":"extras"},{"doc":"Copyright (c) 2022 Marcus Autenrieth Dredd is licensed under the MIT License, see LICENSE.md for details.","ref":"readme.html#copyright-and-license","title":"Dredd - Copyright and License","type":"extras"},{"doc":"All notable changes to Dredd will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Breaking Changes This is a complete rewrite from the structure inherited by Justify. There are two reasons for the overhaul: I have a need for more deeply nested datastructures and needed the more verbose errors to keep output manageable. I wanted to improve the composability of validators. As it were, the architecture looked a bit lopsided.","ref":"changelog.html#2-0-0-2022-12-28","title":"Changelog - [2.0.0] - 2022-12-28","type":"extras"}]